package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _btadmin = null;
public static anywheresoftware.b4a.objects.Serial _btserial = null;
public static com.rootsoft.broadcastreceiver.BroadCastReceiver _broadcast = null;
public static String _devicename = "";
public static String _devicemac = "";
public anywheresoftware.b4a.objects.ButtonWrapper _btnstartdiscovery = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 47;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(16384);
 BA.debugLineNum = 48;BA.debugLine="Activity.LoadLayout(\"main\")";
Debug.ShouldStop(32768);
mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
 BA.debugLineNum = 49;BA.debugLine="BtAdmin.Initialize(\"BtAdmin\")";
Debug.ShouldStop(65536);
_btadmin.Initialize(processBA,"BtAdmin");
 BA.debugLineNum = 50;BA.debugLine="BtAdmin.Enable";
Debug.ShouldStop(131072);
_btadmin.Enable();
 BA.debugLineNum = 51;BA.debugLine="BtSerial.Initialize(\"BtSerial\")";
Debug.ShouldStop(262144);
_btserial.Initialize("BtSerial");
 BA.debugLineNum = 52;BA.debugLine="Broadcast_Init";
Debug.ShouldStop(524288);
_broadcast_init();
 BA.debugLineNum = 53;BA.debugLine="End Sub";
Debug.ShouldStop(1048576);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 58;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(33554432);
 BA.debugLineNum = 59;BA.debugLine="End Sub";
Debug.ShouldStop(67108864);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 55;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(4194304);
 BA.debugLineNum = 56;BA.debugLine="End Sub";
Debug.ShouldStop(8388608);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _broadcast_init() throws Exception{
		Debug.PushSubsStack("Broadcast_Init (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 111;BA.debugLine="Sub Broadcast_Init";
Debug.ShouldStop(16384);
 BA.debugLineNum = 112;BA.debugLine="Broadcast.Initialize(\"BroadCastReceiver\")";
Debug.ShouldStop(32768);
_broadcast.Initialize(processBA,"BroadCastReceiver");
 BA.debugLineNum = 113;BA.debugLine="Broadcast.addAction(\"android.bluetooth.device.action.PAIRING_REQUEST\")";
Debug.ShouldStop(65536);
_broadcast.addAction("android.bluetooth.device.action.PAIRING_REQUEST");
 BA.debugLineNum = 114;BA.debugLine="Broadcast.SetPriority(2147483647)";
Debug.ShouldStop(131072);
_broadcast.SetPriority((int)(2147483647));
 BA.debugLineNum = 115;BA.debugLine="Broadcast.registerReceiver(\"\")";
Debug.ShouldStop(262144);
_broadcast.registerReceiver("");
 BA.debugLineNum = 116;BA.debugLine="End Sub";
Debug.ShouldStop(524288);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _broadcastreceiver_onreceive(String _action,Object _i) throws Exception{
		Debug.PushSubsStack("BroadCastReceiver_OnReceive (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.IntentWrapper _intnt = null;
leongcc.BtAutoPair _autopair = null;
byte[] _pinbytes = null;
Debug.locals.put("Action", _action);
Debug.locals.put("i", _i);
 BA.debugLineNum = 118;BA.debugLine="Sub BroadCastReceiver_OnReceive (Action As String,  i As  Object)    'Event handler";
Debug.ShouldStop(2097152);
 BA.debugLineNum = 119;BA.debugLine="Dim  intnt  As  Intent = i";
Debug.ShouldStop(4194304);
_intnt = new anywheresoftware.b4a.objects.IntentWrapper();
_intnt.setObject((android.content.Intent)(_i));Debug.locals.put("intnt", _intnt);
 BA.debugLineNum = 121;BA.debugLine="Broadcast.AbortBroadcast";
Debug.ShouldStop(16777216);
_broadcast.AbortBroadcast();
 BA.debugLineNum = 122;BA.debugLine="Dim autopair As BtAutoPair";
Debug.ShouldStop(33554432);
_autopair = new leongcc.BtAutoPair();Debug.locals.put("autopair", _autopair);
 BA.debugLineNum = 123;BA.debugLine="Dim pinBytes() As  Byte";
Debug.ShouldStop(67108864);
_pinbytes = new byte[(int)(0)];
;Debug.locals.put("pinBytes", _pinbytes);
 BA.debugLineNum = 125;BA.debugLine="If (Action = \"android.bluetooth.device.action.PAIRING_REQUEST\") Then";
Debug.ShouldStop(268435456);
if (((_action).equals("android.bluetooth.device.action.PAIRING_REQUEST"))) { 
 BA.debugLineNum = 126;BA.debugLine="If (intnt.HasExtra(\"android.bluetooth.device.extra.DEVICE\")) Then";
Debug.ShouldStop(536870912);
if ((_intnt.HasExtra("android.bluetooth.device.extra.DEVICE"))) { 
 BA.debugLineNum = 127;BA.debugLine="Log(\"Pairing request: \" & DeviceName & \", \" & DeviceMac)";
Debug.ShouldStop(1073741824);
anywheresoftware.b4a.keywords.Common.Log("Pairing request: "+_devicename+", "+_devicemac);
 BA.debugLineNum = 136;BA.debugLine="pinBytes = Array As Byte(0x31, 0x31, 0x31, 0x31, 0x31, 0x31)	'passkey=\"111111\"";
Debug.ShouldStop(128);
_pinbytes = new byte[]{(byte)(0x31),(byte)(0x31),(byte)(0x31),(byte)(0x31),(byte)(0x31),(byte)(0x31)};Debug.locals.put("pinBytes", _pinbytes);
 BA.debugLineNum = 137;BA.debugLine="autopair.Start4(intnt, pinBytes)";
Debug.ShouldStop(256);
_autopair.Start4((android.content.Intent)(_intnt.getObject()),_pinbytes);
 };
 };
 BA.debugLineNum = 140;BA.debugLine="End Sub";
Debug.ShouldStop(2048);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btadmin_devicefound(String _name,String _mac) throws Exception{
		Debug.PushSubsStack("BtAdmin_DeviceFound (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Name", _name);
Debug.locals.put("Mac", _mac);
 BA.debugLineNum = 82;BA.debugLine="Sub BtAdmin_DeviceFound (Name As String, Mac As String)	'Event handler";
Debug.ShouldStop(131072);
 BA.debugLineNum = 84;BA.debugLine="BtAdmin.CancelDiscovery";
Debug.ShouldStop(524288);
_btadmin.CancelDiscovery();
 BA.debugLineNum = 87;BA.debugLine="DeviceName  = Name";
Debug.ShouldStop(4194304);
_devicename = _name;
 BA.debugLineNum = 88;BA.debugLine="DeviceMac = Mac";
Debug.ShouldStop(8388608);
_devicemac = _mac;
 BA.debugLineNum = 89;BA.debugLine="Log(\"Device found: \" & DeviceName & \", \" & DeviceMac)";
Debug.ShouldStop(16777216);
anywheresoftware.b4a.keywords.Common.Log("Device found: "+_devicename+", "+_devicemac);
 BA.debugLineNum = 97;BA.debugLine="BtSerial.Connect(DeviceMac)";
Debug.ShouldStop(1);
_btserial.Connect(processBA,_devicemac);
 BA.debugLineNum = 98;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btadmin_discoveryfinished() throws Exception{
		Debug.PushSubsStack("BtAdmin_DiscoveryFinished (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 72;BA.debugLine="Sub BtAdmin_DiscoveryFinished	'Event handler";
Debug.ShouldStop(128);
 BA.debugLineNum = 73;BA.debugLine="Log(\"Discovery stopped\")";
Debug.ShouldStop(256);
anywheresoftware.b4a.keywords.Common.Log("Discovery stopped");
 BA.debugLineNum = 74;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btadmin_statechanged(int _newstate,int _oldstate) throws Exception{
		Debug.PushSubsStack("BtAdmin_StateChanged (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("NewState", _newstate);
Debug.locals.put("OldState", _oldstate);
 BA.debugLineNum = 76;BA.debugLine="Sub BtAdmin_StateChanged (NewState As Int, OldState As Int) 'Event handler";
Debug.ShouldStop(2048);
 BA.debugLineNum = 77;BA.debugLine="If   (NewState =BtAdmin.STATE_OFF) Then";
Debug.ShouldStop(4096);
if ((_newstate==_btadmin.STATE_OFF)) { 
 BA.debugLineNum = 78;BA.debugLine="BtAdmin.Enable";
Debug.ShouldStop(8192);
_btadmin.Enable();
 };
 BA.debugLineNum = 80;BA.debugLine="End Sub";
Debug.ShouldStop(32768);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btnstartdiscovery_click() throws Exception{
		Debug.PushSubsStack("btnStartDiscovery_Click (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 61;BA.debugLine="Sub btnStartDiscovery_Click";
Debug.ShouldStop(268435456);
 BA.debugLineNum = 62;BA.debugLine="DeviceName  = \"\"";
Debug.ShouldStop(536870912);
_devicename = "";
 BA.debugLineNum = 63;BA.debugLine="DeviceMac = \"\"";
Debug.ShouldStop(1073741824);
_devicemac = "";
 BA.debugLineNum = 64;BA.debugLine="BtAdmin.StartDiscovery";
Debug.ShouldStop(-2147483648);
_btadmin.StartDiscovery();
 BA.debugLineNum = 65;BA.debugLine="Log(\"Start discovery\")";
Debug.ShouldStop(1);
anywheresoftware.b4a.keywords.Common.Log("Start discovery");
 BA.debugLineNum = 66;BA.debugLine="End Sub";
Debug.ShouldStop(2);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _btserial_connected(boolean _success) throws Exception{
		Debug.PushSubsStack("BtSerial_Connected (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("Success", _success);
 BA.debugLineNum = 100;BA.debugLine="Sub BtSerial_Connected (Success As Boolean)	' Event handler";
Debug.ShouldStop(8);
 BA.debugLineNum = 101;BA.debugLine="If (Success=True) Then";
Debug.ShouldStop(16);
if ((_success==anywheresoftware.b4a.keywords.Common.True)) { 
 BA.debugLineNum = 102;BA.debugLine="Log(\"Connected\")";
Debug.ShouldStop(32);
anywheresoftware.b4a.keywords.Common.Log("Connected");
 }else {
 BA.debugLineNum = 104;BA.debugLine="Log(\"Not Connected: \" & LastException.Message)";
Debug.ShouldStop(128);
anywheresoftware.b4a.keywords.Common.Log("Not Connected: "+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage());
 };
 BA.debugLineNum = 106;BA.debugLine="End Sub";
Debug.ShouldStop(512);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 44137, new int[] {5}, "819ca1ad-7bc1-4177-8ec9-905cb47897d6");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 39;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 40;BA.debugLine="Dim  btnStartDiscovery As  Button";
mostCurrent._btnstartdiscovery = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 41;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 30;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 31;BA.debugLine="Dim BtAdmin As BluetoothAdmin";
_btadmin = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 32;BA.debugLine="Dim BtSerial As Serial";
_btserial = new anywheresoftware.b4a.objects.Serial();
 //BA.debugLineNum = 33;BA.debugLine="Dim Broadcast As BroadCastReceiver";
_broadcast = new com.rootsoft.broadcastreceiver.BroadCastReceiver();
 //BA.debugLineNum = 35;BA.debugLine="Dim DeviceName As String = \"\"";
_devicename = "";
 //BA.debugLineNum = 36;BA.debugLine="Dim DeviceMac As String = \"\"";
_devicemac = "";
 //BA.debugLineNum = 37;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"BtAdmin",_btadmin,"BtSerial",_btserial,"Broadcast",_broadcast,"DeviceName",_devicename,"DeviceMac",_devicemac,"btnStartDiscovery",_btnstartdiscovery};
}
}
